     import java.util.*;
    
    public class Agenda
    {
    	private String nom;
    	private boolean prive = false;
    	
    	protected boolean estPrive() {
			return prive;
		}
		protected void setPrive(boolean prive) {
			this.prive = prive;
		}
		private ArrayList<Activite> rendezVous;
    	
    	
      //-----------------------------------------------------------------------------
        private Hashtable<String, Vector<Activite>> contenu;
      //-----------------------------------------------------------------------------
      public Agenda()
      {
        contenu = new Hashtable<String, Vector<Activite>>();
        rendezVous = new ArrayList<>();
      }
      //-----------------------------------------------------------------------------
      public void ajouteActivite(Activite activite) throws AgendaException
      {
        // Rcupration du jour de l'activit
        Date date = activite.getTrancheHoraire().getDateDebut();
        String dateJour = date.getJour() + "/" + date.getMois() + "/" + date.getAnnee();
        // Rcupration des activits dj enregistres pour ce jour
        Vector<Activite> activites = contenu.get(dateJour);
        if(activites==null) // Aucune activit encore enregistre
        {
          activites = new Vector<Activite>();
          activites.addElement(activite);
          contenu.put(dateJour,activites);
        }
        else // une/des activit(s) dj enregisrtre(s) pour ce jour
        {
          // Contrle pour s'assurer que l'acticit  insrer n'en chevauche pas une
          // autre
          for (int i=0;i<activites.size();i++)
          {
            Activite a = activites.elementAt(i);
            if(activite.getTrancheHoraire().chevauche(a.getTrancheHoraire()))
              throw new AgendaException(  "Impossible d'inserer cette activite car elle\n"
                                        + "chevauche une autre activite de l'agenda :\n"
                                        + a);
          }
          activites.addElement(activite);
        }
      }
      //-----------------------------------------------------------------------------
      public void supprimeActivite(Activite activite)
      {
        //  implmenter...
      }
      //-----------------------------------------------------------------------------
      public void afficheContenu()
      {
        Enumeration<String> keys = contenu.keys();
        while(keys.hasMoreElements())
        {
          String jour = keys.nextElement();
          System.out.println("\nActivites pour la date du : " + jour);
          System.out.println("======================================");
          Vector<Activite> activites = contenu.get(jour);
          for(int i=0;i<activites.size();i++)
          {
            Activite a = activites.get(i);
            System.out.println(a);
          }
        }
      }
      //-----------------------------------------------------------------------------
    }
    