 public class TrancheHoraire
    {
      //-----------------------------------------------------------------------------
      private Date dateDebut,dateFin;
      private int duree;
      //-----------------------------------------------------------------------------
      public TrancheHoraire(Date dateDebut,Date dateFin) throws AgendaException
      {
        // La tranche horaire doit respecter l'ordre des dates :
        // dateDebut < dateFin
        // Sinon dclenchement d'une exception.
        if(dateFin.avant(dateDebut) || dateFin.identique(dateDebut))
          throw new AgendaException(  "Tranche horaire invalide,\n"
                                    + "la date de fin est IDENTIQUE ou AVANT la date de dbut :\n"
                                    + "Date de debut = " + dateDebut + "\n"
                                    + "Date de fin   = " + dateFin);
    
        // Pour tre valable, une tranche horaire doit concerner deux dates du mme
        // jour.
        if(!dateDebut.memeJour(dateFin))
          throw new AgendaException( "Tranche horaire invalide,\n"
                                    + "les deux dates ne concernent pas la meme journe :\n"
                                    + "Date de debut = " + dateDebut + "\n"
                                    + "Date de fin   = " + dateFin);
    
        // Mmorisation dans les attributs de la classe des paramtres du constructeur
        this.dateDebut = dateDebut;
        this.dateFin = dateFin;
    
        // Calcul de la dure de la tranche horaire. La dure est exprime en minutes
        duree = (dateFin.getHeure() - dateDebut.getHeure()) * 60
               + (dateFin.getMinute() - dateDebut.getMinute());
    
      }
      //-----------------------------------------------------------------------------
      public Date getDateDebut() { return dateDebut; }
      public Date getDateFin()   { return dateFin; }
      public int  getDuree()     { return duree; }
      //-----------------------------------------------------------------------------
      public boolean chevauche(TrancheHoraire th)
      {
        if(dateFin.avant(th.getDateDebut()) || dateFin.identique(th.getDateDebut()))
          return false;
        else
        {
          if(dateDebut.apres(th.getDateFin()) || dateDebut.identique(th.getDateFin()))
            return false;
        }
        return true;
    //    return (
    //            !(
    //                 dateFin.avant(th.getDateDebut())
    //              || dateDebut.apres(th.getDateFin())
    //              )
    //            );
      }
      //-----------------------------------------------------------------------------
      public String toString()
      {
        return ("Tranche horaire de " + dateDebut + " -> " + dateFin + " [" + duree + " min]");
      }
      //-----------------------------------------------------------------------------
    }
    
    
